<?php

namespace common\logic\Setting\SettingDetails\Admin;

use common\logic\Setting\SettingDefinition;
use common\logic\Setting\SettingDetails\Admin\General\AdministratorEmailAdminSetting;
use common\logic\Setting\SettingDetails\Admin\General\AdministratorPhoneNumberAdminSetting;
use common\logic\Setting\SettingDetails\Admin\General\IsTestAdminSetting;
use common\logic\Setting\SettingDetails\Admin\General\SupportEmailAdminSetting;
use common\logic\Setting\SettingDetails\Admin\General2\AnOtherTestAdminSetting;

class AdminSettingDefinition extends SettingDefinition
{
    const SECTION_GENERAL = 'general';
    const SUBSECTION_GENERAL = 'general.main';

    const SECTION_GENERAL2 = 'general2';
    const SUBSECTION_GENERAL2 = 'general2.main';

    public function getSettingDetails(): array
    {
        return [
            self::SECTION_GENERAL => [
                self::SUBSECTION_GENERAL => [
                    new AdministratorEmailAdminSetting,
                    new SupportEmailAdminSetting,
                    new AdministratorPhoneNumberAdminSetting,
                    new IsTestAdminSetting,
                ]
            ],
            self::SECTION_GENERAL2 => [
                self::SUBSECTION_GENERAL2 => [
                    new AnOtherTestAdminSetting,
                ],
            ]
        ];
    }

    public function getSectionLabels(): array
    {
        return [
            self::SECTION_GENERAL => 'General',
            self::SUBSECTION_GENERAL => 'General',

            self::SECTION_GENERAL2 => 'General deux',
            self::SUBSECTION_GENERAL2 => 'General deux',
        ];
    }

    public function getSettingDetailsFlat(): array
    {
        $settingDetailsFlatArray = [];

        foreach($this->getSettingDetails() as $sectionsArray) {
            foreach($sectionsArray as $subsectionsArray) {
                foreach($subsectionsArray as $settingDetail) {
                    $settingDetailsFlatArray[] = $settingDetail;
                }
            }
        }

        return $settingDetailsFlatArray;
    }

    public function getSectionLabelBySectionName(string $sectionName): string
    {
        return $this->getSectionLabels()[$sectionName];
    }
}